#include "OpenGLContext.hpp"
#include "quark/Core.hpp"

#include <GLFW/glfw3.h>
#include <glad/gl.h>

namespace qk {
	OpenGLContext::OpenGLContext(GLFWwindow* window) :
		window(window)
	{
		
	}

	void OpenGLContext::Init() {
		glfwMakeContextCurrent(window);

		int version = gladLoadGL(glfwGetProcAddress);
		QK_CORE_ASSERT(version, "Failed to load OpenGL");

		QK_CORE_INFO("Set up OpenGL context: {0}.{1}", GLAD_VERSION_MAJOR(version), GLAD_VERSION_MINOR(version));

	}

	void OpenGLContext::SwapBuffers() {
		glfwSwapBuffers(window);	
	}
}
