#pragma once

#ifndef NDEBUG
#	include <signal.h>
#	include "quark/Logger.hpp"
#	define _LINE_TO_STR(x) #x
#	define LINE_TO_STR(x) _LINE_TO_STR(x)
#	define QK_ASSERT(x, ...) { if (!(x)) { QK_CRITICAL(__FILE__ ":" LINE_TO_STR(__LINE__) ": Assertion failed: {0}", __VA_ARGS__); raise(SIGTRAP); } }
#	define QK_CORE_ASSERT(x, ...) { if (!(x)) { QK_CORE_CRITICAL(__FILE__ ":" LINE_TO_STR(__LINE__) ": Assertion failed: {0}", __VA_ARGS__); raise(SIGTRAP); } }
#else
#	define QK_ASSERT
#	define QK_CORE_ASSERT
#endif
