#pragma once
// IWYU pragma: private, include <quark.hpp>

namespace qk {
	class Input {
	public:
		static bool IsKeyDown(int keyCode) { return instance->IntIsKeyDown(keyCode); }

		static bool IsMouseDown(int button) { return instance->IntIsMouseDown(button); }
		static std::pair<float, float> GetMousePosition() { return instance->IntGetMousePosition(); }

	protected:
		virtual bool IntIsKeyDown(int keyCode) = 0;

		virtual bool IntIsMouseDown(int button) = 0;
		virtual std::pair<float, float> IntGetMousePosition() = 0;

	private:
		static Input* instance;
	};
}
