#include "IoTranslate.hpp"

#include "quark/MouseButtonCodes.hpp"
#include "quark/KeyCodes.hpp"

namespace qk {
	ImGuiMouseButton MouseButtonToImGuiMouseButton(int button) {
		switch (button) {
			case QK_MOUSE_BUTTON_LEFT:	return ImGuiMouseButton_Left;
			case QK_MOUSE_BUTTON_RIGHT:	return ImGuiMouseButton_Right;
			case QK_MOUSE_BUTTON_MIDDLE:	return ImGuiMouseButton_Middle;
		}

		return button;
	}

	ImGuiKey KeyToImGuiKey(int key) {
		switch (key) {
			case QK_KEY_TAB: return ImGuiKey_Tab;
			case QK_KEY_LEFT: return ImGuiKey_LeftArrow;
			case QK_KEY_RIGHT: return ImGuiKey_RightArrow;
			case QK_KEY_UP: return ImGuiKey_UpArrow;
			case QK_KEY_DOWN: return ImGuiKey_DownArrow;
			case QK_KEY_PAGE_UP: return ImGuiKey_PageUp;
			case QK_KEY_PAGE_DOWN: return ImGuiKey_PageDown;
			case QK_KEY_HOME: return ImGuiKey_Home;
			case QK_KEY_END: return ImGuiKey_End;
			case QK_KEY_INSERT: return ImGuiKey_Insert;
			case QK_KEY_DELETE: return ImGuiKey_Delete;
			case QK_KEY_BACKSPACE: return ImGuiKey_Backspace;
			case QK_KEY_SPACE: return ImGuiKey_Space;
			case QK_KEY_ENTER: return ImGuiKey_Enter;
			case QK_KEY_ESCAPE: return ImGuiKey_Escape;
			case QK_KEY_LEFT_CONTROL: return ImGuiKey_LeftCtrl;
			case QK_KEY_LEFT_SHIFT: return ImGuiKey_LeftShift;
			case QK_KEY_LEFT_ALT: return ImGuiKey_LeftAlt;
			case QK_KEY_LEFT_SUPER: return ImGuiKey_LeftSuper;
			case QK_KEY_RIGHT_CONTROL: return ImGuiKey_RightCtrl;
			case QK_KEY_RIGHT_SHIFT: return ImGuiKey_RightShift;
			case QK_KEY_RIGHT_ALT: return ImGuiKey_RightAlt;
			case QK_KEY_RIGHT_SUPER: return ImGuiKey_RightSuper;
			case QK_KEY_MENU: return ImGuiKey_Menu;
			case QK_KEY_0: return ImGuiKey_0;
			case QK_KEY_1: return ImGuiKey_1;
			case QK_KEY_2: return ImGuiKey_2;
			case QK_KEY_3: return ImGuiKey_3;
			case QK_KEY_4: return ImGuiKey_4;
			case QK_KEY_5: return ImGuiKey_5;
			case QK_KEY_6: return ImGuiKey_6;
			case QK_KEY_7: return ImGuiKey_7;
			case QK_KEY_8: return ImGuiKey_8;
			case QK_KEY_9: return ImGuiKey_9;
			case QK_KEY_A: return ImGuiKey_A;
			case QK_KEY_B: return ImGuiKey_B;
			case QK_KEY_C: return ImGuiKey_C;
			case QK_KEY_D: return ImGuiKey_D;
			case QK_KEY_E: return ImGuiKey_E;
			case QK_KEY_F: return ImGuiKey_F;
			case QK_KEY_G: return ImGuiKey_G;
			case QK_KEY_H: return ImGuiKey_H;
			case QK_KEY_I: return ImGuiKey_I;
			case QK_KEY_J: return ImGuiKey_J;
			case QK_KEY_K: return ImGuiKey_K;
			case QK_KEY_L: return ImGuiKey_L;
			case QK_KEY_M: return ImGuiKey_M;
			case QK_KEY_N: return ImGuiKey_N;
			case QK_KEY_O: return ImGuiKey_O;
			case QK_KEY_P: return ImGuiKey_P;
			case QK_KEY_Q: return ImGuiKey_Q;
			case QK_KEY_R: return ImGuiKey_R;
			case QK_KEY_S: return ImGuiKey_S;
			case QK_KEY_T: return ImGuiKey_T;
			case QK_KEY_U: return ImGuiKey_U;
			case QK_KEY_V: return ImGuiKey_V;
			case QK_KEY_W: return ImGuiKey_W;
			case QK_KEY_X: return ImGuiKey_X;
			case QK_KEY_Y: return ImGuiKey_Y;
			case QK_KEY_Z: return ImGuiKey_Z;
			case QK_KEY_F1: return ImGuiKey_F1;
			case QK_KEY_F2: return ImGuiKey_F2;
			case QK_KEY_F3: return ImGuiKey_F3;
			case QK_KEY_F4: return ImGuiKey_F4;
			case QK_KEY_F5: return ImGuiKey_F5;
			case QK_KEY_F6: return ImGuiKey_F6;
			case QK_KEY_F7: return ImGuiKey_F7;
			case QK_KEY_F8: return ImGuiKey_F8;
			case QK_KEY_F9: return ImGuiKey_F9;
			case QK_KEY_F10: return ImGuiKey_F10;
			case QK_KEY_F11: return ImGuiKey_F11;
			case QK_KEY_F12: return ImGuiKey_F12;
			case QK_KEY_F13: return ImGuiKey_F13;
			case QK_KEY_F14: return ImGuiKey_F14;
			case QK_KEY_F15: return ImGuiKey_F15;
			case QK_KEY_F16: return ImGuiKey_F16;
			case QK_KEY_F17: return ImGuiKey_F17;
			case QK_KEY_F18: return ImGuiKey_F18;
			case QK_KEY_F19: return ImGuiKey_F19;
			case QK_KEY_F20: return ImGuiKey_F20;
			case QK_KEY_F21: return ImGuiKey_F21;
			case QK_KEY_F22: return ImGuiKey_F22;
			case QK_KEY_F23: return ImGuiKey_F23;
			case QK_KEY_F24: return ImGuiKey_F24;
			case QK_KEY_APOSTROPHE: return ImGuiKey_Apostrophe;
			case QK_KEY_COMMA: return ImGuiKey_Comma;
			case QK_KEY_MINUS: return ImGuiKey_Minus;
			case QK_KEY_PERIOD: return ImGuiKey_Period;
			case QK_KEY_SLASH: return ImGuiKey_Slash;
			case QK_KEY_SEMICOLON: return ImGuiKey_Semicolon;
			case QK_KEY_EQUAL: return ImGuiKey_Equal;
			case QK_KEY_LEFT_BRACKET: return ImGuiKey_LeftBracket;
			case QK_KEY_BACKSLASH: return ImGuiKey_Backslash;
			case QK_KEY_RIGHT_BRACKET: return ImGuiKey_RightBracket;
			case QK_KEY_GRAVE_ACCENT: return ImGuiKey_GraveAccent;
			case QK_KEY_CAPS_LOCK: return ImGuiKey_CapsLock;
			case QK_KEY_SCROLL_LOCK: return ImGuiKey_ScrollLock;
			case QK_KEY_NUM_LOCK: return ImGuiKey_NumLock;
			case QK_KEY_PRINT_SCREEN: return ImGuiKey_PrintScreen;
			case QK_KEY_PAUSE: return ImGuiKey_Pause;
			case QK_KEY_KP_0: return ImGuiKey_Keypad0;
			case QK_KEY_KP_1: return ImGuiKey_Keypad1;
			case QK_KEY_KP_2: return ImGuiKey_Keypad2;
			case QK_KEY_KP_3: return ImGuiKey_Keypad3;
			case QK_KEY_KP_4: return ImGuiKey_Keypad4;
			case QK_KEY_KP_5: return ImGuiKey_Keypad5;
			case QK_KEY_KP_6: return ImGuiKey_Keypad6;
			case QK_KEY_KP_7: return ImGuiKey_Keypad7;
			case QK_KEY_KP_8: return ImGuiKey_Keypad8;
			case QK_KEY_KP_9: return ImGuiKey_Keypad9;
			case QK_KEY_KP_DECIMAL: return ImGuiKey_KeypadDecimal;
			case QK_KEY_KP_DIVIDE: return ImGuiKey_KeypadDivide;
			case QK_KEY_KP_MULTIPLY: return ImGuiKey_KeypadMultiply;
			case QK_KEY_KP_SUBTRACT: return ImGuiKey_KeypadSubtract;
			case QK_KEY_KP_ADD: return ImGuiKey_KeypadAdd;
			case QK_KEY_KP_ENTER: return ImGuiKey_KeypadEnter;
			case QK_KEY_KP_EQUAL: return ImGuiKey_KeypadEqual;
		}

		return ImGuiKey_None;
	}
	
}

