#pragma once

// IWYU pragma: private, include <quark.hpp>

#include "quark/events/Event.hpp"

namespace qk {
	class Layer {
	public:
		Layer(const std::string& name = "Layer") :
			debugName(name)
		{ }

		virtual ~Layer() {}

		virtual void OnAttach() {}
		virtual void OnDetach() {}
		virtual void OnUpdate() {}
		virtual void OnEvent(Event& event) {}
		virtual void OnImGuiRender() {}

		inline const std::string& GetName() const { return debugName; }

	protected:
		std::string debugName;
	};
}
