#pragma once

// IWYU pragma: private, include <quark.hpp>
//
#include "quark/Layer.hpp"
#include <list>

namespace qk {
	class LayerStack {
	public:
		using Container = std::list<Layer*>;

	public:
		LayerStack();
		~LayerStack();

		void PushLayer(Layer* layer);
		void PushOverlay(Layer* overlay);

		void PopLayer(Layer* layer);
		void PopOverlay(Layer* layer);

		Container::iterator begin() { return layers.begin(); }
		Container::iterator end() { return layers.end(); }

		Container::reverse_iterator rbegin() { return layers.rbegin(); }
		Container::reverse_iterator rend() { return layers.rend(); }

	private:
		Container layers;
		Container::iterator layerInsert;
	};
}
