#pragma once
// IWYU pragma: private <quark.h>

#include <spdlog/spdlog.h>
#include <spdlog/fmt/ostr.h>

namespace qk {
	class Logger {
	public:
		static void Init();

		inline static std::shared_ptr<spdlog::logger> GetCoreLogger() {
			return coreLogger;
		}

		inline static std::shared_ptr<spdlog::logger> GetClientLogger() {
			return clientLogger;
		}

	private:
		static std::shared_ptr<spdlog::logger> coreLogger;
		static std::shared_ptr<spdlog::logger> clientLogger;
	};
}

#ifndef NDEBUG
#	define QK_CORE_TRACE(...)    ::qk::Logger::GetCoreLogger()->trace(__VA_ARGS__)
#else
#	define QK_CORE_TRACE
#endif
#define QK_CORE_INFO(...)     ::qk::Logger::GetCoreLogger()->info(__VA_ARGS__)
#define QK_CORE_WARN(...)     ::qk::Logger::GetCoreLogger()->warn(__VA_ARGS__)
#define QK_CORE_ERROR(...)    ::qk::Logger::GetCoreLogger()->error(__VA_ARGS__)
#define QK_CORE_CRITICAL(...) ::qk::Logger::GetCoreLogger()->critical(__VA_ARGS__)

#ifndef NDEBUG
#	define QK_TRACE(...)    ::qk::Logger::GetClientLogger()->trace(__VA_ARGS__)
#else
#	define QK_TRACE
#endif
#define QK_INFO(...)     ::qk::Logger::GetClientLogger()->info(__VA_ARGS__)
#define QK_WARN(...)     ::qk::Logger::GetClientLogger()->warn(__VA_ARGS__)
#define QK_ERROR(...)    ::qk::Logger::GetClientLogger()->error(__VA_ARGS__)
#define QK_CRITICAL(...) ::qk::Logger::GetClientLogger()->critical(__VA_ARGS__)
