#pragma once
// IWYU pragma: private, include <quark.hpp>

#include "Event.hpp"

namespace qk {
	class WindowResizeEvent :
		public Event
	{
	public:
		WindowResizeEvent(unsigned int width, unsigned int height) :
			width(width), height(height)
		{ }

		inline unsigned int GetWidth() const { return width; }
		inline unsigned int GetHeight() const { return height; }

		virtual operator std::string() const override {
			std::stringstream ss;
			ss << "WindowResizEvent: " << width << ", " << height;
			return ss.str();
		}

		EVENT_CLASS_TYPE(WindowResize)
		EVENT_CLASS_CATEGORY(EventCategoryApplication)
		
	private:
		unsigned int width, height;
	};

	class WindowCloseEvent :
		public Event
	{
	public:
		EVENT_CLASS_TYPE(WindowClose)
		EVENT_CLASS_CATEGORY(EventCategoryApplication)
	};
}
